// **********************************************************************
//
// Copyright (c) 2001
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <JTC/JTC.h>

#include <stdlib.h>

#ifdef HAVE_IOSTREAM
#  include <iostream>
#else
#  include <iostream.h>
#endif

#ifdef HAVE_STD_IOSTREAM
using namespace std;
#endif

class Reentrant : public JTCMonitor
{
public:

    void
    a()
    {
	JTCSynchronized sync(*this);
	b();
	cout << "here I am, in a()" << endl;
    }

    void
    b()
    {
	JTCSynchronized sync(*this);
	cout << "here I am, in b()" << endl;
    }
};

int
main()
{
    try
    {
	JTCInitialize boot_jtc;

	Reentrant r;
	r.a();
    }
    catch(const JTCException& e)
    {
	cout << "Test failed: " << e.getMessage() << endl;
	return EXIT_FAILURE;
    }

    cout << "Test successful." << endl;
    return EXIT_SUCCESS;
}

