# **********************************************************************
#
# Copyright (c) 2000
# Object Oriented Concepts, Inc.
# Billerica, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= .

!include $(top_srcdir)\config\Make.rules.mak

!if "$(WITH_JTC)" == "yes"
EVENT=event
UTIL=util
NOTIFY=notify
LOGGING=logging
!else
EVENT=
UTIL=
NOTIFY=
LOGGING=
!endif

SUBDIRS		= jtc ob naming property time $(EVENT) $(UTIL) $(NOTIFY) \
                  $(LOGGING)

install install_min::
	@if not exist $(bindir) \
	    @echo "Creating $(bindir)..." & \
	    mkdir $(bindir)

	@if not exist $(libdir) \
	    @echo "Creating $(libdir)..." & \
	    mkdir $(libdir)

	@if not exist $(includedir) \
	    @echo "Creating $(includedir)..." & \
	    mkdir $(includedir)

all depend install clean test min install_min::
	@for %i in ( $(SUBDIRS) ) do \
	    @if exist %i cmd /c "cd %i & $(MAKE) /f Makefile.mak $@"
