dnl **********************************************************************
dnl
dnl Copyright (c) 1999
dnl Object Oriented Concepts, Inc.
dnl Billerica, MA, USA
dnl
dnl All Rights Reserved
dnl
dnl **********************************************************************

dnl ----------------------------------------------------------------------
dnl Obtain JTC version for shared library versioning 
dnl ----------------------------------------------------------------------

AC_SUBST(JTC_LIBVER)
JTC_LIBVER=
jtc_path="../jtc/"
if test -f include/JTC/Thread.h
then
    jtc_path=""
fi
if test -n "$with_jtc" -a "$with_jtc" != "no" -a "$with_jtc" != "yes"
then
    jtc_path="${with_jtc}/"
    if test ! -f ${jtc_path}include/JTC/Thread.h
    then
	jtc_path="${jtc_path}jtc/"
    fi	
fi
if test ! -f ${jtc_path}include/JTC/Thread.h
then
    AC_MSG_ERROR(Can't find JThreads/C++! Use the --with-jtc=path option.)
fi
jtc_ver=""
if test "$LIBEXT" != ".a"
then
    jtc_ver=`grep 'const char\* JTCVersion' \
	< ${jtc_path}src/Version.cpp | sed -e 's/^.* \"//' -e 's/\";$//'`
    JTC_LIBVER=".${jtc_ver}"
fi
if test ! \( -n "$with_jtc" -a "$with_jtc" != "no" -a "$with_jtc" != "yes" \)
then
    jtc_path="\$(top_srcdir)/$jtc_path"
fi
